﻿using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;

namespace HeuristicLab.Problems.DataAnalysis {
  [Item("ParsedConstraint", "Represents parsed constraints.")]
  public class ParsedConstraint : Item {

    protected string input;
    public string Input {
      get => input;
      set => input = value;
    }

    protected IEnumerable<IntervalConstraint> constraints;

    public IEnumerable<IntervalConstraint> Constraints {
      get => constraints;
      set => constraints = value;
    }

    protected ParsedConstraint(ParsedConstraint original, Cloner cloner)
      : base(original, cloner) {
      this.input = original.Input ?? string.Empty;
      this.constraints = original.Constraints ?? new List<IntervalConstraint>();
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new ParsedConstraint(this, cloner);
    }

    public ParsedConstraint() {
      this.input = string.Empty;
      this.constraints = new List<IntervalConstraint>();
    }

    public ParsedConstraint(string input) {
      this.input = input;
      this.constraints = new List<IntervalConstraint>();
    }

    public ParsedConstraint(string input, IEnumerable<IntervalConstraint> constraints) {
      this.input = input;
      this.constraints = constraints;
    }
  }
}
